#
# spec file for package n00btetris
#
# Copyright (c) 2020 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#

%define unmangled_version 0.230919-0
Name:           flappyufo
Version:		0.230919
Release:        0
Summary:    	Clone Flappy Bird from Android
License:        GPL
URL:            https://prymula.ct8.pl
Source0:	%{name}-%{unmangled_version}.tar.gz
%if 0%{?suse_version}==1530
BuildRequires:	java-11-openjdk, ant
Requires:       java-11-openjdk
%else
BuildRequires:	java-latest-openjdk, ant
Requires:		java-latest-openjdk
%endif
BuildArch:	noarch

%description


%prep
%setup -n %{name}-%{unmangled_version} -n %{name}-%{unmangled_version}

%build
ant compile
ant jar

%install
mkdir -p %{buildroot}/usr
mkdir -p %{buildroot}/usr/bin
mkdir -p %{buildroot}/usr/share
mkdir -p %{buildroot}/usr/share/flappyufo
mkdir -p %{buildroot}/usr/share/applications

#%make_install

install -m 0644 build/jar/FlappyUfo.jar %{buildroot}/usr/bin
install -m 0644 res/flappyufo.png %{buildroot}/usr/share/flappyufo
install -m 0644 flappyufo.desktop %{buildroot}/usr/share/applications

%files
%defattr(0755,root,root)
%{_datadir}/flappyufo/
/usr/games/
%defattr(0644,root,root)
/usr/bin/FloppyUfo.jar
%{_datadir}/pixmaps/floppyufo.png
%{_datadir}/applications/floppyufo.desktop

%changelog
